Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/README
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/README	(revision 10343)
+++ 	(revision )
@@ -1,7 +1,0 @@
-## List of available test cases is in demo_cfgs.txt
-
-## HOW TO COMPILE TEST CASES :
-
-In the same manner as ref. cfg with '-r' option, use makenemo with '-a' option
-
-./makenemo -n WAD2 -a WAD -m macport_osx -j 4
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/README.rst
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/README.rst	(revision 10345)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/README.rst	(revision 10345)
@@ -0,0 +1,119 @@
+**********************
+Explore the test cases
+**********************
+
+.. contents::
+	:local:
+
+List
+====
+
+  The description below is a brief description of the test cases available in NEMO. 
+
+ICEDYN
+------
+  
+  This test case illustrates the advection of an ice patch across a East/West and North/South periodic channel. 
+  This configuration can be used to test the advection of the ice patch in an AGRIF zoom (1:3) 
+  and across the AGRIF boundary or to test the ice advection schemes (Prather and Ultimate-Macho). 
+  In the latest case user need to remove ``key_agrif`` out of the CPP keys list. 
+
+  .. image:: _static/ICEDYN_UDIAG_43days_UM5.gif
+
+VORTEX
+------
+  
+  This test case illustrates the propagation of an anticyclonic eddy over a Beta plan and a flat bottom.
+  It is implemented here with an online refined subdomain (1:3) out of which the vortex propagates.
+  It serves as a benchmark for quantitative estimates of nesting errors as in Debreu et al. (2012) :cite:`DEBREU2012`,
+  Penven et al. (2006) :cite:`PENVEN2006` or Spall and Holland (1991) :cite:`SPALL1991`.
+  
+  The animation below (sea level anomaly in meters) illustrates with two 1:2 successively nested grids how
+  the vortex smoothly propagates out of the refined grids.
+  
+  .. image:: _static/VORTEX_anim.gif
+
+ISOMIP
+------
+
+  The purpose of this test case is to evaluate the impact of various schemes and new development with the iceshelf cavities circulation and melt.
+  This configuration served as initial assesment of the ice shelf module in Losh et al. (2008) :cite:`LOSCH2008` and Mathiot et al. (2017) :cite:`MATHIOT2017`. 
+  The default setup is the one described `here <http://staff.acecrc.org.au/~bkgalton/ISOMIP/test_cavities.pdf>`_.
+  
+  The figure below (meridional overturning circulation) illustrates the circulation generated after 10000 days by the ice shelf melting (ice pump).
+
+  .. image:: _static/ISOMIP_moc.png
+
+LOCK_EXCHANGE
+-------------
+
+  The LOCK EXCHANGE experiment is a classical fluid dynamics experiment that has been adapted
+  by Haidvogel and Beckmann (1999) :cite:`HAIDVOGEL1999` for testing advection schemes in ocean circulation models.
+  It has been used by several authors including Burchard and Bolding (2002) :cite:`BURCHARD2002` and Ilicak et al. (2012) :cite:`ILICAK2012`.
+  The LOCK EXCHANGE experiment can in particular illustrate the impact of different choices of numerical schemes 
+  and/or subgrid closures on spurious interior mixing.
+
+  Below the animation of the LOCK_EXCHANGE test case using the advection scheme FCT4 (forth order) for tracer and ubs for dynamics.
+
+  .. image:: _static/LOCK-FCT4_flux_ubs.gif
+
+OVERFLOW
+--------
+
+  The OVERFLOW experiment illustrates the impact of different choices of numerical schemes 
+  and/or subgrid closures on spurious interior mixing close to bottom topography. 
+  The OVERFLOW experiment is adapted from the non-rotating overflow configuration described 
+  in Haidvogel and Beckmann (1999) :cite:`HAIDVOGEL1999` and further used by Ilicak et al. (2012) :cite:`ILICAK2012`.
+  Here we can assess the behaviour of the second-order tracer advection scheme FCT2 and fortht-order FCT4, z-coordinate and sigma coordinate (...).
+
+  Below the animation of the OVERFLOW test case in sigma coordinate with the forth-order advection scheme FCT4.
+
+  .. image:: _static/OVF-sco_FCT4_flux_cen-ahm1000.gif
+
+WAD
+---
+
+  A set of simple closed basin geometries for testing the Wetting and drying capabilities. 
+  Examples range from a closed channel with EW linear bottom slope to a parabolic EW channel with a Gaussian ridge.
+  
+  Below the animation of the test case 7. This test case is a simple linear slope with a mid-depth shelf with an open boundary forced with a sinusoidally varying ssh.
+  This test case has been introduced to emulate a typical coastal application with a tidally forced open boundary with an adverse SSH gradient that, when released, creates a surge up the slope.
+  The parameters are chosen such that the surge rises above sea-level before falling back and oscillating towards an equilibrium position
+
+  .. image:: _static/wad_testcase_7.gif
+
+CANAL
+-----
+
+  East-west periodic canal of variable size with several initial states and associated geostrophic currents (zonal jets or vortex).
+
+  .. image::_static/CANAL_image.gif
+
+Compile test cases
+==================
+
+The compilation of the test cases is very similar to the manner the reference configurations are compiled.
+If you are not familiar on how to compile NEMO, it is first recomended to read :doc:`the instructions <install>`
+
+| In the same manner as the ref. cfg are compiled with '-r' option, test cases can be compile by the use of makenemo with '-a' option.
+
+| Here an example to compile a copy named WAD2 of the wetting and drying test case (WAD) on the macport_osx architecture on 4 cores:
+
+.. code-block:: console
+ 
+	$ ./makenemo -n WAD2 -a WAD -m macport_osx -j 4
+
+Run and analyse the test cases
+==============================
+
+There no requirement of specific input file for the test_cases presented here. The XIOS xml input files and namelist are already setup correctly. 
+For detailed description and Jupyter notebook, the reader is directed on
+the `NEMO test cases repository <http://github.com/NEMO-ocean/NEMO-examples>`_
+
+References
+==========
+
+.. bibliography:: test_cases.bib
+	:all:
+	:style: unsrt
+	:labelprefix: T
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/test_cases.bib
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/test_cases.bib	(revision 10345)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/test_cases.bib	(revision 10345)
@@ -0,0 +1,88 @@
+@book{HAIDVOGEL1999,
+   author = {D. B. Haidvogel and A. Beckmann},
+   publisher = {Imperial College Press, London},
+   year = {1999},
+   title = {Numerical ocean circulation modeling}
+}
+
+@book{BURCHARD2002,
+   title={GETM: A General Estuarine Transport Model; Scientific Documentation},
+   author={Burchard, Hans and Bolding, Karsten},
+   year={2002},
+   publisher={European Commission, Joint Research Centre, Institute for Environment and Sustainability}
+}
+
+@article{ILICAK2012,
+   title = "Spurious dianeutral mixing and the role of momentum closure",
+   journal = "Ocean Modelling",
+   volume = "45-46",
+   pages = "37 - 58",
+   year = "2012",
+   issn = "1463-5003",
+   doi = "10.1016/j.ocemod.2011.10.003",
+   author = "Mehmet Ilicak and Alistair J. Adcroft and Stephen M. Griffies and Robert W. Hallberg",
+   keywords = "Spurious dianeutral transport, Cabbeling, Overflows, Exchange-flow, Ocean models, Momentum transport, Tracer advection, Reference potential energy"
+}
+
+@article{DEBREU2012,
+   title = "Two-way nesting in split-explicit ocean models: Algorithms, implementation and validation",
+   journal = "Ocean Modelling",
+   volume = "49-50",
+   pages = "1 - 21",
+   year = "2012",
+   issn = "1463-5003",
+   doi = "10.1016/j.ocemod.2012.03.003",
+   author = "Laurent Debreu and Patrick Marchesiello and Pierrick Penven and Gildas Cambon",
+   keywords = "Two-way nesting, Finite difference method, Modeling, Boundary conditions, Coastal upwelling"
+}
+
+@article{PENVEN2006,
+   title = "Evaluation and application of the ROMS 1-way embedding procedure to the central california upwelling system",
+   journal = "Ocean Modelling",
+   volume = "12",
+   number = "1",
+   pages = "157 - 187",
+   year = "2006",
+   issn = "1463-5003",
+   doi = "10.1016/j.ocemod.2005.05.002",
+   author = "Pierrick Penven and Laurent Debreu and Patrick Marchesiello and James C. McWilliams",
+   keywords = "Ocean models, Boundary conditions, Embedding, Coastal upwelling, Mesoscale eddies, Eddy kinetic energy, North America, West Coast, Central upwelling system, Monterey Bay, 35–41°N, 128–121°W"
+}
+
+@article{SPALL1991,
+   author = {Spall, M. A. and Holland, W. R.},
+   title = {A Nested Primitive Equation Model for Oceanic Applications},
+   journal = {Journal of Physical Oceanography},
+   volume = {21},
+   number = {2},
+   pages = {205-220},
+   year = {1991},
+   doi = {10.1175/1520-0485(1991)021<0205:ANPEMF>2.0.CO;2},
+}
+
+@article{MATHIOT2017,
+   author = {Mathiot, P. and Jenkins, A. and Harris, C. and Madec, G.},
+   title = {Explicit representation and parametrised impacts of under ice shelf seas in the ${z}^{\ast}$ coordinate ocean model NEMO 3.6},
+   journal = {Geoscientific Model Development},
+   volume = {10},
+   year = {2017},
+   number = {7},
+   pages = {2849--2874},
+   url = {https://www.geosci-model-dev.net/10/2849/2017/},
+   doi = {10.5194/gmd-10-2849-2017}
+}
+
+@article{LOSCH2008,
+   author = {Losch, M.},
+   title = {Modeling ice shelf cavities in a z coordinate ocean general circulation model},
+   journal = {Journal of Geophysical Research: Oceans},
+   volume = {113},
+   year = {2008},
+   number = {C8},
+   pages = {},
+   keywords = {Ice shelf cavities, numerical ocean modeling, z coordinates},
+   doi = {10.1029/2007JC004368},
+   url = {https://agupubs.onlinelibrary.wiley.com/doi/abs/10.1029/2007JC004368},
+   eprint = {https://agupubs.onlinelibrary.wiley.com/doi/pdf/10.1029/2007JC004368},
+   abstract = {Processes at the ice shelf-ocean interface and in particular in ice shelf cavities around Antarctica have an observable effect on the solutions of basin scale to global coupled ice-ocean models. Despite this, these processes are not routinely represented in global ocean and climate models. It is shown that a new ice shelf cavity model for z coordinate models can reproduce results from an intercomparison project of earlier approaches with vertical ?~C or isopycnic coordinates. As a proof of concept, ice shelves are incorporated in a 100-year global integration of a z coordinate model. In this simulation, glacial meltwater can be traced as far as north as 15??S. The observed effects of processes in the ice shelf cavities agree with previous results from a ?~C coordinate model, notably the increase in sea ice thickness. However, melt rates are overestimated probably because the parameterization of basal melting does not suit the low resolution of this configuration.}
+}