Index: MO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/context_nemo-CMIP6.xml
===================================================================
--- /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/context_nemo-CMIP6.xml	(revision 10347)
+++ 	(revision )
@@ -1,154 +1,0 @@
-<!--
- ============================================================================================== 
-    NEMO context
-============================================================================================== 
--->
-<context id="nemo">
-<!-- $id$ -->
-<!-- Fields definition -->
-    <field_definition src="./field_def_nemo-oce.xml"/>   <!--  NEMO ocean dynamics                     -->
-    <field_definition src="./field_def_nemo-ice.xml"/>   <!--  NEMO ocean sea ice                      -->
-<!--    <field_definition src="./field_def_nemo-bgc.xml"/>   <!--  NEMO ocean biogeochemistry with PISCES  -->
-
-
-<!-- Files definition -->
-    <file_definition src="./file_def_nemo-oce-CMIP6.xml"/>     <!--  NEMO ocean dynamics                     -->
-    <file_definition src="./file_def_nemo-ice-CMIP6.xml"/>     <!--  NEMO ocean sea ice                      -->
-<!--    <file_definition src="./file_def_nemo-bgc.xml"/>     <!--  NEMO ocean biogeochemistry with PISCES  -->
-    <!-- 
-============================================================================================================
-= grid definition = = DO NOT CHANGE =
-============================================================================================================
-    -->
-    
-    <axis_definition>
-      <axis id="deptht" long_name="Vertical T levels" unit="m" positive="down" />
-      <axis id="deptht300" axis_ref="deptht" >
-         <zoom_axis begin="0" n="35" />
-      </axis>
-      <axis id="depthu" long_name="Vertical U levels" unit="m" positive="down" />
-      <axis id="depthv" long_name="Vertical V levels" unit="m" positive="down" />
-      <axis id="depthw" long_name="Vertical W levels" unit="m" positive="down" />
-      <axis id="nfloat" long_name="Float number"      unit="-"                 />
-      <axis id="icbcla"  long_name="Iceberg class"      unit="1"               />
-      <axis id="ncatice" long_name="Ice category"       unit="1"               />
-      <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"            />
-      <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"            />
-    </axis_definition>
- 
-    <domain_definition src="./domain_def_nemo.xml"/>
-  
-    <grid_definition>    
-
-        <!--  -->
-       <grid id="grid_T_2D" >
-         <domain id="grid_T" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D_ncatice" >
-         <domain id="grid_T" />
-         <axis id="ncatice" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3D" >
-         <domain id="grid_T" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_2D" >
-         <domain id="grid_U" />
-       </grid>
-        <!--  -->
-       <grid id="grid_U_3D" >
-         <domain id="grid_U" />
-         <axis id="depthu" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_2D" >
-         <domain id="grid_V" />
-       </grid>
-        <!--  -->
-       <grid id="grid_V_3D" >
-         <domain id="grid_V" />
-         <axis id="depthv" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_2D" >
-         <domain id="grid_W" />
-       </grid>
-        <!--  -->
-       <grid id="grid_W_3D" >
-         <domain id="grid_W" />
-         <axis id="depthw" />
-       </grid>
-        <!--  -->
-       <grid id="grid_1point" >
-         <domain domain_ref="1point"/>
-       </grid>
-        <!--  -->
-       <grid id="grid_T_nfloat" >
-         <domain id="grid_T" />
-         <axis id="nfloat" />
-       </grid>
-        <!--  -->
-       <grid id="grid_EqT" >
-         <domain domain_ref="EqT" />
-       </grid>
-        <!--  -->
-       <grid id="gznl_T_2D">
-         <domain id="gznl" />
-       </grid>
-        <!--  -->
-       <grid id="gznl_T_3D">
-         <domain id="gznl" />
-         <axis id="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="gznl_W_3D">
-         <domain id="gznl" />
-         <axis id="depthw" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-       <domain id="ptr" />
-      </grid>
-
-      <grid id="grid_ptr_T_3D">
-       <domain id="ptr" />
-         <axis id="deptht" />
-       </grid>
-
-      <grid id="grid_ptr_W_3D">
-       <domain id="ptr" />
-         <axis id="depthw" />
-      </grid>
-
-       <grid id="vert_sum">
-         <domain domain_ref="grid_T"/>
-         <scalar>
-            <reduce_axis operation="sum" />
-         </scalar>
-       </grid>
-
-       <grid id="zoom_300">
-         <domain domain_ref="grid_T" />
-         <axis axis_ref="deptht300"/>
-       </grid>
-
-       <grid id="zoom_300_sum">
-         <domain domain_ref="grid_T" />
-         <scalar>
-            <reduce_axis operation="sum" />
-         </scalar>
-       </grid>
-
-       <grid id="grid_T_SFC">
-         <domain domain_ref="grid_T" />
-         <scalar>
-           <extract_axis position="0" />
-         </scalar>
-       </grid>
-
-    </grid_definition>   
-
-</context>
Index: /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/context_nemo.xml	(revision 10348)
+++ /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/context_nemo.xml	(revision 10348)
@@ -0,0 +1,154 @@
+<!--
+ ============================================================================================== 
+    NEMO context
+============================================================================================== 
+-->
+<context id="nemo">
+<!-- $id$ -->
+<!-- Fields definition -->
+    <field_definition src="./field_def_nemo-oce.xml"/>   <!--  NEMO ocean dynamics                     -->
+    <field_definition src="./field_def_nemo-ice.xml"/>   <!--  NEMO ocean sea ice                      -->
+<!--    <field_definition src="./field_def_nemo-bgc.xml"/>   <!--  NEMO ocean biogeochemistry with PISCES  -->
+
+
+<!-- Files definition -->
+    <file_definition src="./file_def_nemo-oce-CMIP6-1M.xml"/>     <!--  NEMO ocean dynamics                     -->
+    <file_definition src="./file_def_nemo-ice-CMIP6-1M.xml"/>     <!--  NEMO ocean sea ice                      -->
+<!--    <file_definition src="./file_def_nemo-bgc.xml"/>     <!--  NEMO ocean biogeochemistry with PISCES  -->
+    <!-- 
+============================================================================================================
+= grid definition = = DO NOT CHANGE =
+============================================================================================================
+    -->
+    
+    <axis_definition>
+      <axis id="deptht" long_name="Vertical T levels" unit="m" positive="down" />
+      <axis id="deptht300" axis_ref="deptht" >
+         <zoom_axis begin="0" n="35" />
+      </axis>
+      <axis id="depthu" long_name="Vertical U levels" unit="m" positive="down" />
+      <axis id="depthv" long_name="Vertical V levels" unit="m" positive="down" />
+      <axis id="depthw" long_name="Vertical W levels" unit="m" positive="down" />
+      <axis id="nfloat" long_name="Float number"      unit="-"                 />
+      <axis id="icbcla"  long_name="Iceberg class"      unit="1"               />
+      <axis id="ncatice" long_name="Ice category"       unit="1"               />
+      <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"            />
+      <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"            />
+    </axis_definition>
+ 
+    <domain_definition src="./domain_def_nemo.xml"/>
+  
+    <grid_definition>    
+
+        <!--  -->
+       <grid id="grid_T_2D" >
+         <domain id="grid_T" />
+       </grid>
+        <!--  -->
+       <grid id="grid_T_3D_ncatice" >
+         <domain id="grid_T" />
+         <axis id="ncatice" />
+       </grid>
+        <!--  -->
+       <grid id="grid_T_3D" >
+         <domain id="grid_T" />
+         <axis id="deptht" />
+       </grid>
+        <!--  -->
+       <grid id="grid_U_2D" >
+         <domain id="grid_U" />
+       </grid>
+        <!--  -->
+       <grid id="grid_U_3D" >
+         <domain id="grid_U" />
+         <axis id="depthu" />
+       </grid>
+        <!--  -->
+       <grid id="grid_V_2D" >
+         <domain id="grid_V" />
+       </grid>
+        <!--  -->
+       <grid id="grid_V_3D" >
+         <domain id="grid_V" />
+         <axis id="depthv" />
+       </grid>
+        <!--  -->
+       <grid id="grid_W_2D" >
+         <domain id="grid_W" />
+       </grid>
+        <!--  -->
+       <grid id="grid_W_3D" >
+         <domain id="grid_W" />
+         <axis id="depthw" />
+       </grid>
+        <!--  -->
+       <grid id="grid_1point" >
+         <domain domain_ref="1point"/>
+       </grid>
+        <!--  -->
+       <grid id="grid_T_nfloat" >
+         <domain id="grid_T" />
+         <axis id="nfloat" />
+       </grid>
+        <!--  -->
+       <grid id="grid_EqT" >
+         <domain domain_ref="EqT" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_T_2D">
+         <domain id="gznl" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_T_3D">
+         <domain id="gznl" />
+         <axis id="deptht" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_W_3D">
+         <domain id="gznl" />
+         <axis id="depthw" />
+       </grid>
+
+      <grid id="grid_ptr_T_2D">
+       <domain id="ptr" />
+      </grid>
+
+      <grid id="grid_ptr_T_3D">
+       <domain id="ptr" />
+         <axis id="deptht" />
+       </grid>
+
+      <grid id="grid_ptr_W_3D">
+       <domain id="ptr" />
+         <axis id="depthw" />
+      </grid>
+
+       <grid id="vert_sum">
+         <domain domain_ref="grid_T"/>
+         <scalar>
+            <reduce_axis operation="sum" />
+         </scalar>
+       </grid>
+
+       <grid id="zoom_300">
+         <domain domain_ref="grid_T" />
+         <axis axis_ref="deptht300"/>
+       </grid>
+
+       <grid id="zoom_300_sum">
+         <domain domain_ref="grid_T" />
+         <scalar>
+            <reduce_axis operation="sum" />
+         </scalar>
+       </grid>
+
+       <grid id="grid_T_SFC">
+         <domain domain_ref="grid_T" />
+         <scalar>
+           <extract_axis position="0" />
+         </scalar>
+       </grid>
+
+    </grid_definition>   
+
+</context>
Index: /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/iodef.xml
===================================================================
--- /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/iodef.xml	(revision 10347)
+++ /NEMO/branches/UKMO/2018_NEMO4_beta_mirror_10037_Benchmark/cfgs/METO_GO/EXPREF/iodef.xml	(revision 10348)
@@ -10,5 +10,7 @@
       <variable_definition>
 	
-	  <variable id="info_level"                type="int">10</variable>
+	  <variable id="info_level"                type="int">0</variable>
+          <variable id="optimal_buffer_size"       type="string">performance</variable>
+          <variable id="recv_field_timeout"        type="double">1800</variable>
 	  <variable id="using_server"              type="bool">true</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>