Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/AGRIF_DEMO/cpp_AGRIF_DEMO.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/AGRIF_DEMO/cpp_AGRIF_DEMO.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/AGRIF_DEMO/cpp_AGRIF_DEMO.fcm	(revision 10360)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys   key_si3 key_iomput key_mpp_mpi key_nosignedzero key_agrif
+bld::tool::fppkeys   key_si3 key_iomput key_mpp_mpi key_agrif
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/cpp_ORCA2_ICE_PISCES.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/cpp_ORCA2_ICE_PISCES.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/cpp_ORCA2_ICE_PISCES.fcm	(revision 10360)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys   key_si3 key_top key_iomput key_mpp_mpi key_nosignedzero
+bld::tool::fppkeys   key_si3 key_top key_iomput key_mpp_mpi 
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SPITZ12/cpp_SPITZ12.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SPITZ12/cpp_SPITZ12.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SPITZ12/cpp_SPITZ12.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_mpp_mpi key_iomput key_nosignedzero key_si3
+ bld::tool::fppkeys key_mpp_mpi key_iomput key_si3
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/OCE/nemogcm.F90
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/OCE/nemogcm.F90	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/OCE/nemogcm.F90	(revision 10360)
@@ -555,5 +555,6 @@
       !
       IF( 1._wp /= SIGN(1._wp,-0._wp)  )   CALL ctl_stop( 'nemo_ctl: The intrinsec SIGN function follows f2003 standard.',  &
-         &                                                'Compile with key_nosignedzero enabled' )
+         &                                                'Compile with key_nosignedzero enabled:',   &
+         &                                                '--> add -Dkey_nosignedzero to the definition of %CPP in your arch file' )
       !
 #if defined key_agrif
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/CANAL/cpp_CANAL.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/CANAL/cpp_CANAL.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/CANAL/cpp_CANAL.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_iomput key_mpp_mpi key_nosignedzero 
+ bld::tool::fppkeys key_iomput key_mpp_mpi 
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ICEDYN/cpp_ICEDYN.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ICEDYN/cpp_ICEDYN.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ICEDYN/cpp_ICEDYN.fcm	(revision 10360)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_agrif key_si3 key_mpp_mpi key_nosignedzero key_iomput
+bld::tool::fppkeys key_agrif key_si3 key_mpp_mpi key_iomput
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ISOMIP/cpp_ISOMIP.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ISOMIP/cpp_ISOMIP.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/ISOMIP/cpp_ISOMIP.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys   key_iomput key_mpp_mpi key_nosignedzero 
+ bld::tool::fppkeys   key_iomput key_mpp_mpi 
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/LOCK_EXCHANGE/cpp_LOCK_EXCHANGE.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/LOCK_EXCHANGE/cpp_LOCK_EXCHANGE.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/LOCK_EXCHANGE/cpp_LOCK_EXCHANGE.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys   key_iomput key_mpp_mpi key_nosignedzero
+ bld::tool::fppkeys   key_iomput key_mpp_mpi 
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/OVERFLOW/cpp_OVERFLOW.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/OVERFLOW/cpp_OVERFLOW.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/OVERFLOW/cpp_OVERFLOW.fcm	(revision 10360)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys   key_mpp_mpi key_iomput key_nosignedzero
+bld::tool::fppkeys   key_mpp_mpi key_iomput 
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/VORTEX/cpp_VORTEX.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/VORTEX/cpp_VORTEX.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/VORTEX/cpp_VORTEX.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_iomput key_mpp_mpi key_nosignedzero key_agrif
+ bld::tool::fppkeys key_iomput key_mpp_mpi key_agrif
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/WAD/cpp_WAD.fcm
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/WAD/cpp_WAD.fcm	(revision 10359)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/tests/WAD/cpp_WAD.fcm	(revision 10360)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys   key_iomput key_mpp_mpi key_nosignedzero
+ bld::tool::fppkeys   key_iomput key_mpp_mpi 