Index: NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml
===================================================================
--- NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10362)
+++ NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10363)
@@ -240,4 +240,19 @@
        <field id="Irondep"     long_name="Iron deposition from dust"               unit="mol/m2/s"                        />
        <field id="Ironsed"     long_name="Iron deposition from sediment"           unit="mol/m2/s"   grid_ref="grid_T_3D" />
+      <field id="FESCAV"      long_name="Scavenging of Iron"                      unit="mmol-Fe/m3/s"   grid_ref="grid_T_3D" />
+       <field id="FECOLL"      long_name="Colloidal Pumping of FeL"                unit="mmol-FeL/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LGWCOLL"     long_name="Coagulation loss of ligands"             unit="mmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="REMINF"      long_name="Oxic remineralization suppy of Fe"       unit="mmol-Fe/m3/s"  grid_ref="grid_T_3D" />
+       <field id="BACT"        long_name="Bacterial Biomass"                       unit="mmol/m3"  grid_ref="grid_T_3D" />
+       <field id="FEBACT"      long_name="Bacterial uptake of Fe"                  unit="molFe/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODR"      long_name="OM remineralisation ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODP"      long_name="phytoplankton ligand production rate"    unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LIGREM"      long_name="Remineralisation loss of ligands"        unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LIGPR"       long_name="Photochemical loss of ligands"           unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LDETP"       long_name="Ligand destruction during phytoplankton uptake" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODZ2"     long_name="mesozooplankton ligand production rate"  unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODZ"      long_name="microzooplankton ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FEZOO"       long_name="microzooplankton iron recycling rate"    unit="nmol-FeL/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FEZOO2"      long_name="mesozooplankton iron recycling rate"     unit="nmol-FeL/m3/s"  grid_ref="grid_T_3D" />
 
        <!-- dbio_T on T grid : variables available with diaar5 -->
Index: NEMO/trunk/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10362)
+++ NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10363)
@@ -55,6 +55,6 @@
 !                         !  ln_ligand enabled
    wfep       =  0.2      ! FeP sinking speed 
-   ldocp      =  1.E-5    ! Phyto ligand production per unit doc 
-   ldocz      =  1.E-5    ! Zoo ligand production per unit doc 
+   ldocp      =  1.E-4    ! Phyto ligand production per unit doc 
+   ldocz      =  1.E-4    ! Zoo ligand production per unit doc 
    lthet      =  0.5      ! Proportional loss of ligands due to Fe uptake 
 !                         !  ln_p5z enabled
@@ -210,8 +210,8 @@
    resrat2    =  0.005    ! exsudation rate of mesozooplankton
    mzrat2     =  0.03     ! mesozooplankton mortality rate
-   xprefc     =  1.       ! mesozoo preference for diatoms
-   xprefp     =  0.3      ! mesozoo preference for nanophyto.
-   xprefz     =  1.       ! mesozoo preference for microzoo.
-   xprefpoc   =  0.3      ! mesozoo preference for poc
+   xpref2d    =  1.       ! mesozoo preference for diatoms
+   xpref2n    =  0.3      ! mesozoo preference for nanophyto.
+   xpref2z    =  1.       ! mesozoo preference for microzoo.
+   xpref2c    =  0.3      ! mesozoo preference for poc
    xthresh2zoo = 1E-8     ! zoo feeding threshold for mesozooplankton 
    xthresh2dia = 1E-8     ! diatoms feeding threshold for mesozooplankton 
@@ -221,4 +221,5 @@
    xkgraz2    =  20.E-6   ! half saturation constant for meso grazing
    epsher2    =  0.35     ! Efficicency of Mesozoo growth
+   epsher2min =  0.35     ! Minimum efficiency of mesozoo growth
    sigma2     =  0.6      ! Fraction of mesozoo excretion as DOM
    unass2     =  0.3      ! non assimilated fraction of P by mesozoo
@@ -246,4 +247,5 @@
    xkgraz2     =  20.E-6   ! half sturation constant for meso grazing
    epsher2     =  0.5      ! Efficicency of Mesozoo growth
+   epsher2min  =  0.2     ! Minimum efficiency of mesozoo growth
    ssigma2     =  0.5     ! Fraction excreted as semi-labile DOM
    srespir2    =  0.2     ! Active respiration
@@ -260,7 +262,7 @@
    resrat     =  0.03     ! exsudation rate of zooplankton
    mzrat      =  0.004    ! zooplankton mortality rate
-   xpref2c    =  0.1      ! Microzoo preference for POM
-   xpref2p    =  1.       ! Microzoo preference for Nanophyto
-   xpref2d    =  0.5      ! Microzoo preference for Diatoms
+   xprefc     =  0.1      ! Microzoo preference for POM
+   xprefn     =  1.       ! Microzoo preference for Nanophyto
+   xprefd     =  0.6      ! Microzoo preference for Diatoms
    xthreshdia =  1.E-8    ! Diatoms feeding threshold for microzooplankton 
    xthreshphy =  1.E-8    ! Nanophyto feeding threshold for microzooplankton 
@@ -269,4 +271,5 @@
    xkgraz     =  20.E-6   ! half sturation constant for grazing
    epsher     =  0.3      ! Efficiency of microzoo growth
+   epshermin  =  0.3      ! Minimum efficiency of microzoo growth
    sigma1     =  0.6      ! Fraction of microzoo excretion as DOM
    unass      =  0.3      ! non assimilated fraction of phyto by zoo
@@ -293,4 +296,5 @@
    xkgraz     =  20.E-6   ! half sturation constant for grazing
    epsher     =  0.5      ! Efficiency of microzoo growth
+   epshermin  =  0.2      ! Minimum efficiency of microzoo growth
    ssigma     =  0.5      ! Fraction excreted as semi-labile DOM
    srespir    =  0.2      ! Active respiration
@@ -304,9 +308,8 @@
    ln_fechem =  .false.   ! complex iron chemistry ( T/F )
    ln_ligvar =  .false.   ! variable ligand concentration
-   ln_fecolloid = .false. ! variable colloidal fraction
    xlam1        =  0.005  ! scavenging rate of Iron
    xlamdust     =  150.0  ! Scavenging rate of dust
    ligand       =  0.6E-9 ! Ligands concentration 
-   kfep         =  0.     ! Nanoparticle formation rate constant
+   kfep         =  0.01   ! Nanoparticle formation rate constant
 /
 !-----------------------------------------------------------------------  
@@ -383,4 +386,5 @@
    fep_rats    =  1.       ! Fep/Fer ratio from sed sources 
    fep_rath    =  1.       ! Fep/Fer ratio from sed hydro sources 
+   rdustfep    =  0.0      ! Fraction of dust that is FeP
    lgw_rath    =  0.5      ! Weak ligand ratio from sed hydro sources 
 /
@@ -389,8 +393,8 @@
 !-----------------------------------------------------------------------
    rfep        =  0.001    ! Dissolution rate of FeP
-   rlgw        =  1.       ! Lifetime (years) of weak ligands
+   rlgw        =  100.     ! Lifetime (years) of weak ligands
    rlig        =  1.E-4    ! Remin ligand production per unit C
    prlgw       =  1.E-4    ! Photolysis of weak ligand
-   rlgs        =  1000.    ! Lifetime (years) of strong ligands
+   rlgs        =  1.       ! Lifetime (years) of strong ligands
 /
 !-----------------------------------------------------------------------